// *********************(c)*2004*********************>
// -holzilib--holzilib--holzilib--holzilib--holzilib->
// ++++PD-External++by+Georg+Holzmann++grh@gmx.at++++>
//
// PDContainer: 
// this is a port of the containers from the C++ STL
// (Standard Template Library)
// for usage see the documentation and PD help files
// for license see readme.txt
//
// GlobalStuff.h 


#ifndef _global_stuff_h___
#define _global_stuff_h___


#include "m_pd.h"
#include <string>
#include <sstream>
#include <fstream>
#include <iterator>


using std::string;
using std::ostringstream;
using std::istringstream;
using std::ofstream;
using std::ifstream;


typedef t_atom atom;


//---------------------------------------------------
// some kind of hack be me to handle the template-stuff:
// these defines are unfortunately necessary, because some
// compilers can't handle export template ...
#ifndef NT
#define  TemplateDefinition     export template<class ContainerType, class ContTypeIterator>
#else
#define  TemplateDefinition     template<class ContainerType, class ContTypeIterator>
#endif // NT


//---------------------------------------------------
/* one element contains the data (an PD t_atom) and
 * an string for the specific namespace
 */ 
struct Element
{
  atom data;
  string h_namespace;
};

//---------------------------------------------------
/* this class is needed for the map, set, ... to
 * compare the struct Element
 */
class Compare
{
 public:
  bool operator()(const Element &key1,const Element &key2) const
    {
      if (key1.h_namespace == key2.h_namespace)
	// nummern unterschiedlich vergleichen  !!!!
	return strcmp(atom_gensym(const_cast<atom*>(&key1.data))->s_name, 
		      atom_gensym(const_cast<atom*>(&key2.data))->s_name) < 0;
      else
	return strcmp(key1.h_namespace.c_str(),
		      key2.h_namespace.c_str()) < 0;
    }
};


#endif //_global_stuff_h___
