// *********************(c)*2004*********************>
// -holzilib--holzilib--holzilib--holzilib--holzilib->
// ++++PD-External++by+Georg+Holzmann++grh@gmx.at++++>
//
// PDContainer: 
// this is a port of the containers from the C++ STL
// (Standard Template Library)
// for usage see the documentation and PD help files
// for license see readme.txt
//
// TMapBase.h

#ifndef t_map_base_h__
#define t_map_base_h__


#include "include/TPDContainer.h"



//---------------------------------------------------
/* this is the base class of map and multimap
 */
template <class ContainerType, class ContTypeIterator>
class TMapBase : public TPDContainer<ContainerType,ContTypeIterator>
{

 private:

  /* Copy Construction is not allowed
   */
  TMapBase(const TMapBase<ContainerType,ContTypeIterator> &src)
    { }

  /* assignement operator is not allowed
   */
  const TMapBase<ContainerType,ContTypeIterator>& operator = 
    (const TMapBase<ContainerType,ContTypeIterator>&)
    { }

 public:

  /* Standard Constructor
   * no namespace
   */
  TMapBase()
    { }

  /* Destructor
   */
  virtual ~TMapBase() { };

  /* adds a key-value pair
   */
  virtual void add(atom key, atom value);

  /* gets a value to the specific key
   */
  virtual atom &get(atom &key) const;


  // the following methods overwrites the methods from TPDContainer

  /* prints all the data of the current namespace to the console
   */
  virtual void printAll();

  /* saves all the data of the current namespace to a file
   * Fileformat: <key_type> <key> <data_type> <data>
   * e.g.:
   * s foo f 12.34234
   * s foo s hallo
   * type: s=symbol, f=float
   * ATTENTION: if the file exists, all the old data of
   * the file is lost
   * returns true on success
   */
  virtual bool saveToFile(string filename);

  /* Fileformat: <key_type> <key> <data_type> <data>
   * e.g.:
   * s foo f 12.34234
   * s foo s hallo
   * type: s=symbol, f=float
   * returns true on success
   */
  virtual bool readFromFile(string filename);
};


// the following inclusion is unfortunately not avoidable
// (because of the template stuff)
#ifdef NT
#include "src/TMapBase.cpp"
#endif // NT


#endif  // t_map_base_h__
