// *********************(c)*2004*********************>
// -holzilib--holzilib--holzilib--holzilib--holzilib->
// ++++PD-External++by+Georg+Holzmann++grh@gmx.at++++>
//
// PDContainer: 
// this is a port of the containers from the C++ STL
// (Standard Template Library)
// for usage see the documentation and PD help files
// for license see readme.txt
//
// TPDContainer.h

#ifndef t_pd_container_h___
#define t_pd_container_h___


#include "include/GlobalStuff.h"



//---------------------------------------------------
/* this is the base class of all the containers
 */
template <class ContainerType, class ContTypeIterator>
class TPDContainer
{
 protected:

  /* this is the static container with all the datas
   */
  static ContainerType data_;

  /* this string is the namespace of the current object
   */
  string h_namespace_;

  /* this string is the name of the datatype
   * (e.g. h_set, h_map, ...)
   */
  string dataname_;

 private:

  /* Copy Construction is not allowed
   */
  TPDContainer(const TPDContainer<ContainerType,ContTypeIterator> &src)
    { }

  /* assignement operator is not allowed
   */
  const TPDContainer<ContainerType,ContTypeIterator>& operator = 
    (const TPDContainer<ContainerType,ContTypeIterator>&)
    { }

 public:

  /* Standard Constructor
   * no namespace
   */
  TPDContainer()
    { }

  /* Destructor
   */
  virtual ~TPDContainer() 
    { } 

  /* sets the namespace variable
   */
  void setNamespace(string h_namespace)
    {   h_namespace_ = h_namespace;   }

  /* get the namespace string
   */ 
  string getNamespace() const
    {   return h_namespace_;   }

  /* clears all the data of all namespaces
   * off all objects from the same container
   */
  virtual void clearAll();
  
  /* clears all the data of the current namespaces
   * in all objects from the same container
   */
  virtual void clearNamespace();  

  /* prints all the data of the current namespace to the console
   */
  virtual void printAll();

  /* saves all the data of the current namespace to a file
   * Fileformat: <data_type> <data>
   * e.g.:
   * f 12.34234
   * s foo
   * type: s=symbol, f=float
   * ATTENTION: if the file exists, all the old data of
   * the file is lost
   * ATTENTION: some containers (e.g. map) have other
   * fileformats !
   * returns true on success
   */
  virtual bool saveToFile(string filename);

  /* adds the data of the file to the current namespace
   * Fileformat: <data_type> <data>
   * e.g.:
   * f 12.34234
   * s foo
   * type: s=symbol, f=float
   * ATTENTION: some containers (e.g. map) have other
   * fileformats !
   * returns true on success
   */
  virtual bool readFromFile(string filename);
};


// the following inclusion is unfortunately not avoidable
// (because of the template stuff)
#ifdef NT
#include "src/TPDContainer.cpp"
#endif // NT 


#endif //t_pd_container_h___
