// *********************(c)*2004*********************>
// -holzilib--holzilib--holzilib--holzilib--holzilib->
// ++++PD-External++by+Georg+Holzmann++grh@gmx.at++++>
//
// h_map:
// 
// DEMO of the STL map


#include "include/HMap.h"


static t_class *h_map_class;

typedef struct _h_map 
{
  t_object  x_obj;
  t_canvas *x_canvas;
  HMap *hmap;
} t_h_map;

static void h_map_add(t_h_map *x, t_symbol *s,  int argc, t_atom *argv)
{
  switch(argc)
    {
    case 2:
      x->hmap->add(argv[0], argv[1]);
      break;
    default:
      post("h_map, add: wrong number of arguments"); 
      break;
    }
}

static void h_map_get(t_h_map *x, t_symbol *s,  int argc, t_atom *argv)
{
  t_atom output;

  switch(argc)
    {
    case 1:
      output = x->hmap->get( argv[0] );
      break;
    default:
      post("h_map, set: wrong number of arguments"); 
      break;
    }
  //check the type, then make the typespecific outlet
  if (output.a_type == A_FLOAT)
    outlet_float(x->x_obj.ob_outlet, output.a_w.w_float);
  if (output.a_type == A_SYMBOL)
    outlet_symbol(x->x_obj.ob_outlet, output.a_w.w_symbol);
}

static void h_map_help(t_h_map *x)
{
  post("helptext");
}

static void h_map_set_namespace(t_h_map *x, t_symbol *s)
{
  x->hmap->setNamespace(s->s_name);
}

static void h_map_get_namespace(t_h_map *x)
{
  post("h_map current namespace: %s",x->hmap->getNamespace().c_str());
}

static void h_map_print(t_h_map *x)
{
  x->hmap->printAll();
}

static void h_map_clear(t_h_map *x)
{
  x->hmap->clearNamespace();
}

static void h_map_save(t_h_map *x, t_symbol *s)
{
  // make correct path
  char filnam[MAXPDSTRING];
  char filename[MAXPDSTRING];
  canvas_makefilename(x->x_canvas, s->s_name, filnam, MAXPDSTRING);
  sys_bashfilename(filnam, filename);

  if(x->hmap->saveToFile(filename))
    post("h_map: data of namespace %s written to file %s",
	 x->hmap->getNamespace().c_str(),s->s_name);
  else
    post("h_map: couldn't write to file %s",s->s_name);
}

static void h_map_read(t_h_map *x, t_symbol *s)
{
  // make correct path
  char filnam[MAXPDSTRING];
  char filename[MAXPDSTRING];
  canvas_makefilename(x->x_canvas, s->s_name, filnam, MAXPDSTRING);
  sys_bashfilename(filnam, filename);

  if(!x->hmap->readFromFile(filename))
    post("h_map: couldn't read from file %s",s->s_name);
}

static void *h_map_new(t_symbol *s, int argc, t_atom *argv) 
{

  t_h_map *x = (t_h_map *)pd_new(h_map_class);
  
  switch(argc)
    {
    default:
    case 1:
      x->hmap = new HMap(atom_getsymbol(argv)->s_name);
      break;
    case 0:
      x->hmap = new HMap();
      break;
    }

  outlet_new(&x->x_obj,&s_float);
  x->x_canvas = canvas_getcurrent();
    
  return (void *)x;
}

static void *h_map_free(t_h_map *x)
{
  delete x->hmap;
  return (void *)x;
}

extern "C" void h_map_setup(void) 
{
  h_map_class = class_new(gensym("h_map"), (t_newmethod)h_map_new,
				(t_method)h_map_free, sizeof(t_h_map), 
				CLASS_DEFAULT, A_GIMME, 0);

  class_addmethod(h_map_class, (t_method)h_map_add, 
		  gensym("add"), A_GIMME , 0);
  class_addmethod(h_map_class, (t_method)h_map_get, 
		  gensym("get"), A_GIMME , 0);
  class_addmethod(h_map_class, (t_method)h_map_set_namespace, 
		  gensym("namespace"), A_DEFSYMBOL , 0);
  class_addmethod(h_map_class, (t_method)h_map_get_namespace, 
		  gensym("getnamespace"), A_DEFFLOAT, 0);
  class_addmethod(h_map_class, (t_method)h_map_print,
		  gensym("print"), A_DEFFLOAT, 0);
  class_addmethod(h_map_class, (t_method)h_map_clear,  
		  gensym("clear"), A_DEFFLOAT, 0);
  class_addmethod(h_map_class, (t_method)h_map_save, 
		  gensym("save"), A_DEFSYMBOL , 0);
  class_addmethod(h_map_class, (t_method)h_map_read, 
		  gensym("read"), A_DEFSYMBOL , 0);

  // without an argument the following two methods wont work ??? why?? because of c++?
  class_addmethod(h_map_class, (t_method)h_map_help, gensym("help"),A_DEFFLOAT, 0);
}
